#ifndef CSP_SCANNER_H
#define CSP_SCANNER_H

#include <iostream>
#include "csp-parser.hpp"
#include "csp-symtable.hpp"

namespace CSP {

   typedef parser::semantic_type semantic_type;

   class Scanner {
      public:
	 Scanner(std::istream& in_param, const std::string& input_name_param,
	    SymTable& symtab_param);

	 // mutators
	 int get_token(semantic_type& yylval, location& yylloc);

      private:
	 SymTable& symtab;
	 std::istream& in;
	 std::string input_name;
	 unsigned char ch;
	 bool eof;
	 int lasttoken; // last token returned by get_token()
	 position oldpos, pos;
	 location tokenloc;
	 std::string* tokenstr;

	 // private mutators
	 void nextch();
	 void error(char const* msg);
   };

   inline int yylex(semantic_type* yylval, location* yylloc, Scanner& scanner) {
      return scanner.get_token(*yylval, *yylloc);
   }

} // namespace CSP

#endif
