#ifndef CSP_SCOPE_H
#define CSP_SCOPE_H

#include <string>
#include <map>
#include "csp-types.hpp"

namespace CSP {

   class Scope {
      private:
	 typedef std::map<std::string, ProcessDefinitionPtr> ProcMap;
	 ProcMap processes;
	 Scope* outer;
      public:
	 // constructors
	 Scope();
	 Scope(Scope* outer_param);

	 // accessors
	 bool lookup(const std::string& name,
	       ProcessDefinitionPtr& process) const;
	 Scope* get_outer() const;

	 // mutators
	 bool insert(const ProcessDefinitionPtr& process);
   };

} // namespace CSP

#endif
