#include <iostream>
#include <fstream>
#include <cstdlib>
#include "csp-scanner.hpp"
#include "csp-parser.hpp"
#include "csp-yytname.hpp"
#include "csp-symtable.hpp"

using namespace std;
using namespace CSP;

int main(int argc, char** argv) {
   char* cmdname = *argv++; --argc;
   if (argc > 1) {
      cerr << "Usage: " << cmdname << " [filename]" << endl;
      exit(1);
   }

   SymTable symtab;
   Scanner* scanner;
   ifstream* fin = 0;
   if (argc > 0) {
      char* fname = *argv++; --argc;
      fin = new ifstream(fname);
      string filename(fname);
      if (!*fin) {
         cerr << cmdname << ": unable to open " << fname <<
            " for reading" << endl;
         exit(1);
      }
      scanner = new Scanner(*fin, filename, symtab);
   } else {
      scanner = new Scanner(cin, "stdin", symtab);
   }
   ProcessPtr process;
   parser p(*scanner, symtab, process);
   if (p.parse() == 0) {
      cout << "OK" << endl;
   }
   delete scanner;
}
